/*
 * MakroAction.cpp
 *
 *  Created on: Dec 17, 2009
 *      Author: crueger
 */

#include "Actions/MakroAction.hpp"
#include "Actions/Action.hpp"
#include "Actions/ActionSequence.hpp"

MakroAction::MakroAction(ActionSequence* _actions) :
actions(_actions)
{
}

MakroAction::~MakroAction()
{
  Action* action;
  while(action=actions->removeLastAction()){
    delete action;
  }
  delete actions;
}


void MakroAction::call(){
  actions->callAll();
}

void MakroAction::undo() {
  actions->undoAll();
}

bool MakroAction::canUndo() {
  return actions->canUndo();
}
